<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

/*
 * @version       1.0.0
 * @package       JLT_Elementor_Image_Hover_Effect
 * @license       Copyright JLT_Elementor_Image_Hover_Effect
 */

if ( ! function_exists( 'jltimghe_option' ) ) {
	/**
	 * Get setting database option
	 *
	 * @param string $section default section name jltimghe_general .
	 * @param string $key .
	 * @param string $default .
	 *
	 * @return string
	 */
	function jltimghe_option( $section = 'jltimghe_general', $key = '', $default = '' ) {
		$settings = get_option( $section );

		return isset( $settings[ $key ] ) ? $settings[ $key ] : $default;
	}
}

if ( ! function_exists( 'jltimghe_exclude_pages' ) ) {
	/**
	 * Get exclude pages setting option data
	 *
	 * @return string|array
	 *
	 * @version 1.0.0
	 */
	function jltimghe_exclude_pages() {
		return jltimghe_option( 'jltimghe_triggers', 'exclude_pages', array() );
	}
}

if ( ! function_exists( 'jltimghe_exclude_pages_except' ) ) {
	/**
	 * Get exclude pages except setting option data
	 *
	 * @return string|array
	 *
	 * @version 1.0.0
	 */
	function jltimghe_exclude_pages_except() {
		return jltimghe_option( 'jltimghe_triggers', 'exclude_pages_except', array() );
	}
}