<?php
namespace JLTIMGHE\Libs;

// No, Direct access Sir !!!
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'Assets' ) ) {

	/**
	 * Assets Class
	 *
	 * Jewel Theme <support@jeweltheme.com>
	 * @version     1.0.0
	 */
	class Assets {

		/**
		 * Constructor method
		 *
		 * @author Jewel Theme <support@jeweltheme.com>
		 */
		public function __construct() {
			add_action( 'wp_enqueue_scripts', array( $this, 'jltimghe_enqueue_scripts' ), 100 );
			add_action( 'admin_enqueue_scripts', array( $this, 'jltimghe_admin_enqueue_scripts' ), 100 );
		}


		/**
		 * Get environment mode
		 *
		 * @author Jewel Theme <support@jeweltheme.com>
		 */
		public function get_mode() {
			return defined( 'WP_DEBUG' ) && WP_DEBUG ? 'development' : 'production';
		}

		/**
		 * Enqueue Scripts
		 *
		 * @method wp_enqueue_scripts()
		 */
		public function jltimghe_enqueue_scripts() {

			// CSS Files .
			wp_enqueue_style( 'image-hover-effects-elementor-addon-frontend', JLTIMGHE_ASSETS . 'css/image-hover-effects-elementor-addon-frontend.css', JLTIMGHE_VER, 'all' );

			// JS Files .
			wp_enqueue_script( 'image-hover-effects-elementor-addon-frontend', JLTIMGHE_ASSETS . 'js/image-hover-effects-elementor-addon-frontend.js', array( 'jquery' ), JLTIMGHE_VER, true );
		}


		/**
		 * Enqueue Scripts
		 *
		 * @method admin_enqueue_scripts()
		 */
		public function jltimghe_admin_enqueue_scripts() {
			// CSS Files .
			wp_enqueue_style( 'image-hover-effects-elementor-addon-admin', JLTIMGHE_ASSETS . 'css/image-hover-effects-elementor-addon-admin.css', array( 'dashicons' ), JLTIMGHE_VER, 'all' );

			// JS Files .
			wp_enqueue_script( 'image-hover-effects-elementor-addon-admin', JLTIMGHE_ASSETS . 'js/image-hover-effects-elementor-addon-admin.js', array( 'jquery' ), JLTIMGHE_VER, true );
			wp_localize_script(
				'image-hover-effects-elementor-addon-admin',
				'JLTIMGHECORE',
				array(
					'admin_ajax'        => admin_url( 'admin-ajax.php' ),
					'recommended_nonce' => wp_create_nonce( 'jltimghe_recommended_nonce' ),
				)
			);
		}
	}
}