<?php
/**
 * Plugin Name: Image Hover Effects for Elementor
 * Plugin URI:  https://master-addons.com/demos/image-hover-effects/
 * Description: Image Hover Effects addon for elementor page builder plugin. Compare Before and After Images beautifully.
 * Version:     1.0.2.3
 * Author:      Jewel Theme
 * Author URI:  https://jeweltheme.com
 * Text Domain: image-hover-effects-elementor-addon
 * Domain Path: languages/
 * License:     GPLv3 or later
 * License URI: https://www.gnu.org/licenses/gpl-3.0.html
 *
 * @package image-hover-effects-elementor-addon
 */

/*
 * don't call the file directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	wp_die( esc_html__( 'You can\'t access this page', 'image-hover-effects-elementor-addon' ) );
}

$jltimghe_plugin_data = get_file_data(
	__FILE__,
	array(
		'Version'     => 'Version',
		'Plugin Name' => 'Plugin Name',
		'Author'      => 'Author',
		'Description' => 'Description',
		'Plugin URI'  => 'Plugin URI',
	),
	false
);

// Define Constants.
if ( ! defined( 'JLTIMGHE' ) ) {
	define( 'JLTIMGHE', $jltimghe_plugin_data['Plugin Name'] );
}

if ( ! defined( 'JLTIMGHE_VER' ) ) {
	define( 'JLTIMGHE_VER', $jltimghe_plugin_data['Version'] );
}

if ( ! defined( 'JLTIMGHE_AUTHOR' ) ) {
	define( 'JLTIMGHE_AUTHOR', $jltimghe_plugin_data['Author'] );
}

if ( ! defined( 'JLTIMGHE_DESC' ) ) {
	define( 'JLTIMGHE_DESC', $jltimghe_plugin_data['Author'] );
}

if ( ! defined( 'JLTIMGHE_URI' ) ) {
	define( 'JLTIMGHE_URI', $jltimghe_plugin_data['Plugin URI'] );
}

if ( ! defined( 'JLTIMGHE_DIR' ) ) {
	define( 'JLTIMGHE_DIR', __DIR__ );
}

if ( ! defined( 'JLTIMGHE_FILE' ) ) {
	define( 'JLTIMGHE_FILE', __FILE__ );
}

if ( ! defined( 'JLTIMGHE_SLUG' ) ) {
	define( 'JLTIMGHE_SLUG', dirname( plugin_basename( __FILE__ ) ) );
}

if ( ! defined( 'JLTIMGHE_BASE' ) ) {
	define( 'JLTIMGHE_BASE', plugin_basename( __FILE__ ) );
}

if ( ! defined( 'JLTIMGHE_PATH' ) ) {
	define( 'JLTIMGHE_PATH', trailingslashit( plugin_dir_path( __FILE__ ) ) );
}

if ( ! defined( 'JLTIMGHE_URL' ) ) {
	define( 'JLTIMGHE_URL', trailingslashit( plugins_url( '/', __FILE__ ) ) );
}

if ( ! defined( 'JLTIMGHE_INC' ) ) {
	define( 'JLTIMGHE_INC', JLTIMGHE_PATH . '/Inc/' );
}

if ( ! defined( 'JLTIMGHE_LIBS' ) ) {
	define( 'JLTIMGHE_LIBS', JLTIMGHE_PATH . 'Libs' );
}

if ( ! defined( 'JLTIMGHE_ASSETS' ) ) {
	define( 'JLTIMGHE_ASSETS', JLTIMGHE_URL . 'assets/' );
}

if ( ! defined( 'JLTIMGHE_IMAGES' ) ) {
	define( 'JLTIMGHE_IMAGES', JLTIMGHE_ASSETS . 'images' );
}

if ( ! class_exists( '\\JLTIMGHE\\JLT_Elementor_Image_Hover_Effect' ) ) {
	// Autoload Files.
	include_once JLTIMGHE_DIR . '/vendor/autoload.php';
	// Instantiate JLT_Elementor_Image_Hover_Effect Class.
	include_once JLTIMGHE_DIR . '/class-image-hover-effects-elementor-addon.php';
}